package de.tub.mapc.Coordination.messages;

import java.io.IOException;

import de.dailab.keks.io.IDeserialiser;
import de.dailab.keks.io.ISerialiser;
import de.jiac.micro.agent.memory.IFact;
import de.tub.mapc.knowledge.Position;

public class SwitchingAnswer extends Position implements IFact{

	private int distance = -1;
	private Position switchingPosition;
	private String sender = "";
	
	public SwitchingAnswer(){
		
	}
	
	public SwitchingAnswer(int x, int y, int dist, Position switchingP){
		super(x,y);
		distance = dist;
		switchingPosition = switchingP;
	}
	
	@Override
	public void deserialise(IDeserialiser in) throws IOException,
			ClassNotFoundException {
		super.deserialise(in);
		distance = in.readInt();
		switchingPosition = (Position)in.readObject();
		sender = in.readString();
	}

	@Override
	public void serialise(ISerialiser out) throws IOException {
		super.serialise(out);
		out.writeInt(distance);
		out.writeObject(switchingPosition);
		out.writeString(sender);
	}

	public void setDistance(int distance) {
		this.distance = distance;
	}

	public int getDistance() {
		return distance;
	}

	public void setSwitchingPosition(Position switchingPosition) {
		this.switchingPosition = switchingPosition;
	}

	public Position getSwitchingPosition() {
		return switchingPosition;
	}

	public String getSender() {
		return sender;
	}

	public void setSender(String sender) {
		this.sender = sender;
	}

}
