package de.tub.mapc.knowledge;

import java.io.IOException;

import de.dailab.keks.io.IDeserialiser;
import de.dailab.keks.io.ISerialiser;
import de.jiac.micro.agent.memory.IFact;
import de.tub.mapc.worldmodel.GridField;

public class Perception implements IFact {

	private int step;
	private int posx;
	private int posy;
	private int score;
	private long deadline;
	private String id;
	private GridField[] gridInfo;
	private String agentId = "";
	private boolean reachedLastGoal;
	
	public Perception(){
		// scheinbar braucht man einen Konstruktor ohne Argumente fuer das deserialisieren
	}
	
	public Perception(int step, int posx, int posy, int score, long deadline, String id, GridField[] gridInfo){
		this.step = step;
		this.posx = posx;
		this.posy = posy;
		this.score = score;
		this.deadline = deadline;
		this.id = id;
		this.setGridInfo(gridInfo);
		this.setReachedLastGoal(false);
	}
	
	public Position getAgentsPosition(){
		return new Position(posx,posy);
	}
	
	public void setAgentId(String aid){
		agentId = aid;
	}
	
	public int getStep(){
		return step;
	}
	
	public int getScore(){
		return score;
	}
	
	public String getAgentId(){
		return agentId;
	}
	
	public void setGridInfo(GridField[] gridInfo) {
		this.gridInfo = gridInfo;
	}


	public GridField[] getGridInfo() {
		return gridInfo;
	}

	/**
	 * gives the ID of the requestAction message to send it with the actionMessage
	 * @return the id
	 */
	public String getID(){
		return this.id;
	}
	
	public int getPosX(){
		return this.posx;
	}

	public int getPosY(){
		return this.posy;
	}
	
	public void setReachedLastGoal(boolean reachedLastGoal) {
		this.reachedLastGoal = reachedLastGoal;
	}

	public boolean isReachedLastGoal() {
		return reachedLastGoal;
	}

	@Override
	public void deserialise(IDeserialiser arg0) throws IOException,
			ClassNotFoundException {
		step = arg0.readInt();
		posx = arg0.readInt();
		posy = arg0.readInt();
		score = arg0.readInt();
		deadline = arg0.readLong();
		id = arg0.readString();
		agentId = arg0.readString();
		int size = arg0.readInt();
		this.gridInfo = new GridField[size];
		for(int i = 0; i < gridInfo.length; i++){
			gridInfo[i] = (GridField)arg0.readObject();
		}
		reachedLastGoal = arg0.readBoolean();

	}

	@Override
	public void serialise(ISerialiser arg0) throws IOException {
		arg0.writeInt(step);
		arg0.writeInt(posx);
		arg0.writeInt(posy);
		arg0.writeInt(score);
		arg0.writeLong(deadline);
		arg0.writeString(id);
		arg0.writeString(agentId);
		arg0.writeInt(gridInfo.length);
		for(int i = 0; i < gridInfo.length; i++){
			arg0.writeObject(gridInfo[i]);
		}
		arg0.writeBoolean(reachedLastGoal);
	}

	public Position getPosition() {
		return new Position(posx, posy);
	}

}
