package de.tub.mapc.pathfinding;

import de.tub.mapc.knowledge.Position;

public final class AStarNode extends Position implements Comparable {
	public double costFromStart;
	public double estimatedCostToGoal;
	public AStarNode pathParent;
	
	public AStarNode(int x, int y){
		super(x,y);
		reset();
	}
	
	public void reset() {
		costFromStart = 0;
		estimatedCostToGoal = 0;
		pathParent = null;
	}
	
	@Override
	public String toString(){
		return "("+getX()+","+getY()+") : F = "+getCost()+", G = "+costFromStart+", H = "+estimatedCostToGoal;
	}
	
	@Override
	public int compareTo(Object obj){
	    final AStarNode other= (AStarNode) obj;
	    
	    if(getCost() > other.getCost()) {
	        return 1;
	    }
	    if(getCost() < other.getCost()) {
	        return -1;
	    }
	    return 0;
	}
	
	public double getCost()  {
		return costFromStart + estimatedCostToGoal;
	}
}
