package de.tub.mapc.worldmodel;

import java.io.IOException;

import de.dailab.keks.io.IDeserialiser;
import de.dailab.keks.io.ISerialiser;
import de.tub.mapc.knowledge.Position;

public class GridField extends Position{

	private int type;
	private int seenInStep;
	
	public GridField(){
		super();
	}
	
	public GridField(int x, int y, int type, int seenInStep) {
		super(x,y);
		this.setType(type);
		this.setSeenInStep(seenInStep);
	}

	public void setType(int type) {
		this.type = type;
	}

	public int getType() {
		return type;
	}

	public void setSeenInStep(int seenInStep) {
		this.seenInStep = seenInStep;
	}

	public int getSeenInStep() {
		return seenInStep;
	}

	@Override
	public void deserialise(IDeserialiser arg0) throws IOException,
			ClassNotFoundException {
		super.deserialise(arg0);
		type = arg0.readInt();
		seenInStep = arg0.readInt();
		
	}

	@Override
	public void serialise(ISerialiser arg0) throws IOException {
		super.serialise(arg0);
		arg0.writeInt(type);
		arg0.writeInt(seenInStep);
	}

	@Override
	public boolean equals(Object o) {
		if(!(o instanceof GridField))
			return false;
		GridField gf = (GridField)o;
		return type == gf.type && seenInStep == gf.seenInStep && this.getX() == gf.getX() && this.getY() == gf.getY();
	}
}
